osl::eval::ml::King8EffectAll Class Reference

`#include <king8.h>`

## Public Types

enum | { ONE_DIM = 32 , DIM = 32 * 5 * 2 }
enum | EffectState { NOT_EMPTY = -1 , NO_EFFECT = 0 , LESS_EFFECT , MORE_EFFECT , MORE_EFFECT_KING_ONLY }

## Public Member Functions

| King8EffectAll ()

## Static Public Member Functions

static void | setUp (const Weights &weights)
static int | eval (const NumEffectState &state, PieceMask black_mask, PieceMask white_mask)
static void | effectState (const NumEffectState &state, const Player defense, const Direction dir, EffectState &empty, EffectState &)
static int | index (const Direction dir, EffectState state)

## Static Private Attributes

static CArray< int, ONE_DIM > | base_table
static CArray< int, ONE_DIM > | u_table
static CArray< int, ONE_DIM > | d_table
static CArray< int, ONE_DIM > | l_table
static CArray< int, ONE_DIM > | r_table
static CArray< int, ONE_DIM > | base_defense_piece_table
static CArray< int, ONE_DIM > | u_defense_piece_table
static CArray< int, ONE_DIM > | d_defense_piece_table
static CArray< int, ONE_DIM > | l_defense_piece_table
static CArray< int, ONE_DIM > | r_defense_piece_table

## Detailed Description

Definition at line 144 of file core/osl/eval/king8.h.

## Member Enumeration Documentation

## anonymous enum

anonymous enum

Enumerator
ONE_DIM |
DIM |

Definition at line 147 of file core/osl/eval/king8.h.

## EffectState

enum osl::eval::ml::King8EffectAll::EffectState

Enumerator
NOT_EMPTY |
NO_EFFECT |
LESS_EFFECT |
MORE_EFFECT |
MORE_EFFECT_KING_ONLY |

Definition at line 160 of file core/osl/eval/king8.h.

## Constructor & Destructor Documentation

## King8EffectAll()

osl::eval::ml::King8EffectAll::King8EffectAll | ( |  | ) |

inline

Definition at line 169 of file core/osl/eval/king8.h.

## Member Function Documentation

## effectState()

void osl::eval::ml::King8EffectAll::effectState | ( | const NumEffectState & | state,
|  | const Player | defense,
|  | const Direction | dir,
|  | EffectState & | empty,
|  | EffectState & | defense_effect )

static

Definition at line 436 of file king8.cc.

References osl::alt(), osl::Board_Table, osl::NumEffectState::countEffect(), osl::Piece::isEmpty(), osl::Square::isOnBoard(), osl::Piece::isOnBoardByOwner(), osl::SimpleState::kingSquare(), LESS_EFFECT, MORE_EFFECT, MORE_EFFECT_KING_ONLY, NO_EFFECT, NOT_EMPTY, and osl::SimpleState::pieceAt().

Referenced by eval().

## eval()

int osl::eval::ml::King8EffectAll::eval | ( | const NumEffectState & | state,
|  | PieceMask | black_mask,
|  | PieceMask | white_mask )

static

Definition at line 486 of file king8.cc.

References base_defense_piece_table, base_table, osl::BLACK, d_defense_piece_table, d_table, effectState(), osl::NumEffectState::Iking8Info(), index(), l_defense_piece_table, l_table, osl::checkmate::King8Info::liberty(), osl::DirectionTraits< Dir >::mask, NOT_EMPTY, r_defense_piece_table, r_table, osl::SHORT8_DIRECTION_MAX, osl::SHORT8_DIRECTION_MIN, u_defense_piece_table, u_table, and osl::WHITE.

## index()

int osl::eval::ml::King8EffectAll::index | ( | const Direction | dir,
|  | EffectState | state )

static

Definition at line 480 of file king8.cc.

Referenced by eval().

## setUp()

void osl::eval::ml::King8EffectAll::setUp | ( | const Weights & | weights | ) |

static

Definition at line 407 of file king8.cc.

References base_defense_piece_table, base_table, d_defense_piece_table, d_table, l_defense_piece_table, l_table, ONE_DIM, r_defense_piece_table, r_table, u_defense_piece_table, u_table, and osl::eval::ml::Weights::value().

## Member Data Documentation

## base_defense_piece_table

osl::CArray< int, osl::eval::ml::King8EffectAll::ONE_DIM > osl::eval::ml::King8EffectAll::base_defense_piece_table

static private

Definition at line 154 of file core/osl/eval/king8.h.

Referenced by eval(), and setUp().

## base_table

osl::CArray< int, osl::eval::ml::King8EffectAll::ONE_DIM > osl::eval::ml::King8EffectAll::base_table

static private

Definition at line 149 of file core/osl/eval/king8.h.

Referenced by eval(), and setUp().

## d_defense_piece_table

osl::CArray< int, osl::eval::ml::King8EffectAll::ONE_DIM > osl::eval::ml::King8EffectAll::d_defense_piece_table

static private

Definition at line 156 of file core/osl/eval/king8.h.

Referenced by eval(), and setUp().

## d_table

osl::CArray< int, osl::eval::ml::King8EffectAll::ONE_DIM > osl::eval::ml::King8EffectAll::d_table

static private

Definition at line 151 of file core/osl/eval/king8.h.

Referenced by eval(), and setUp().

## l_defense_piece_table

osl::CArray< int, osl::eval::ml::King8EffectAll::ONE_DIM > osl::eval::ml::King8EffectAll::l_defense_piece_table

static private

Definition at line 157 of file core/osl/eval/king8.h.

Referenced by eval(), and setUp().

## l_table

osl::CArray< int, osl::eval::ml::King8EffectAll::ONE_DIM > osl::eval::ml::King8EffectAll::l_table

static private

Definition at line 152 of file core/osl/eval/king8.h.

Referenced by eval(), and setUp().

## r_defense_piece_table

osl::CArray< int, osl::eval::ml::King8EffectAll::ONE_DIM > osl::eval::ml::King8EffectAll::r_defense_piece_table

static private

Definition at line 158 of file core/osl/eval/king8.h.

Referenced by eval(), and setUp().

## r_table

osl::CArray< int, osl::eval::ml::King8EffectAll::ONE_DIM > osl::eval::ml::King8EffectAll::r_table

static private

Definition at line 153 of file core/osl/eval/king8.h.

Referenced by eval(), and setUp().

## u_defense_piece_table

osl::CArray< int, osl::eval::ml::King8EffectAll::ONE_DIM > osl::eval::ml::King8EffectAll::u_defense_piece_table

static private

Definition at line 155 of file core/osl/eval/king8.h.

Referenced by eval(), and setUp().

## u_table

osl::CArray< int, osl::eval::ml::King8EffectAll::ONE_DIM > osl::eval::ml::King8EffectAll::u_table

static private

Definition at line 150 of file core/osl/eval/king8.h.

Referenced by eval(), and setUp().

The documentation for this class was generated from the following files:

- core/osl/eval/king8.h
- king8.cc